﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/**
 * \mainpage API Documentation
 * 
 * Please click on Examples to compare how CPP and C# examples are cross-referenced.
 */

/**
 * \example "Program.cpp"
 * This C++ example has cross references to the C# API.
 * 
 * \example "Program.cs"
 * This C# example has no cross references to the API except in this comment.
 */
namespace API
{
    /// <summary>
    /// This is the interface to the low-level code.
    /// </summary>
    public class ApiClass
    {
        /// <summary>
        /// This is a private member variable.
        /// </summary>
        private int m_value;

        /// <summary>
        /// This provides read-only access to the private member variable.
        /// </summary>
        public int Value { get { return m_value; } set { } }

        /// <summary>
        /// Constructor.
        /// </summary>
        public ApiClass()
        {
            m_value = 0;
        }

        /// <summary>
        /// Increments the private member variable
        /// </summary>
        /// <param name="step">amount (whole number) to increment the member variable</param>
        /// <returns>new incremented value</returns>
        public int Increment(int step)
        {
            m_value += step;
            return m_value;
        }

        /// <summary>
        /// Decrements the private member variable
        /// </summary>
        /// <param name="step">amount (whole number) to decrement the member variable</param>
        /// <returns>new decremented value</returns>
        public int Decrement(int step)
        {
            m_value -= step;
            return m_value;
        }
    }
}
